<jsp:root version="2.0" xmlns:jsp="http://java.sun.com/JSP/Page" xmlns:spring="http://www.springframework.org/tags"
  xmlns:c="http://java.sun.com/jsp/jstl/core" xmlns:fmt="http://java.sun.com/jsp/jstl/fmt"
  xmlns:su="http://openutils.sourceforge.net/openutils-tags-commonslang"
  xmlns:ou="http://openutils.sourceforge.net/openutils-tags-spring"
  xmlns:elx="http://openutils.sourceforge.net/openutils-tags-elx">
  <jsp:directive.attribute name="path" required="true" />
  <jsp:directive.attribute name="name" required="false" />
  <jsp:directive.attribute name="maxlength" required="false" type="java.lang.Integer" />
  <jsp:directive.attribute name="readonly" required="false" type="java.lang.Boolean" />
  <jsp:directive.attribute name="disabled" required="false" type="java.lang.Boolean" />
  <jsp:directive.attribute name="bare" required="false" type="java.lang.Boolean" />
  <jsp:directive.attribute name="type" required="false" />
  <jsp:directive.attribute name="nobind" required="false" type="java.lang.Boolean" />
  <jsp:directive.attribute name="style" required="false" />
  <jsp:directive.attribute name="onkeypress" required="false" />
  <jsp:directive.attribute name="onkeydown" required="false" />
  <jsp:directive.attribute name="onkeyup" required="false" />
  <jsp:directive.attribute name="onchange" required="false" />
  <jsp:directive.attribute name="cssclass" required="false" />
  <jsp:directive.attribute name="key" required="false" />
  <jsp:directive.attribute name="onblur" required="false" />
  <jsp:directive.attribute name="label" required="false" type="java.lang.String" />
  <c:if test="${empty(key)}">
    <c:set var="key" value="${path}" />
  </c:if>
  <c:if test="${empty(type)}">
    <c:set var="type" value="text" />
  </c:if>
  <c:if test="${empty(name)}">
    <c:set var="name">${su:substringAfter(path, ".")}</c:set>
  </c:if>
  <c:if test="${empty(maxlength)}">
    <c:set var="maxlength">30</c:set>
  </c:if>
  <c:if test="${type == 'key' || type == 'keyshow' || type == 'keytext'}">
    <c:choose>
      <c:when test="${type == 'keytext' and empty(status.value)}">
        <c:set var="donothing" value="${true}" />
      </c:when>
      <c:when test="${type == 'key' and !empty(status.value)}">
        <c:set var="type" value="hidden" />
      </c:when>
      <c:when test="${(type == 'keyshow' and !empty(status.value)) or (type == 'keytext' and !empty(status.value))}">
        <c:set var="type" value="text" />
        <c:set var="readonly" value="${true}" />
      </c:when>
      <c:otherwise>
        <c:set var="type" value="text" />
      </c:otherwise>
    </c:choose>
  </c:if>
  <c:if test="${type == 'hidden'}">
    <c:set var="bare" value="${true}" /><!-- don't show labels for hidden fields -->
  </c:if>
  <c:if test="${type == 'date'}">
    <c:set var="type" value="text" />
    <c:set var="datepicker" value="${true}" />
  </c:if>
  <c:if test="${su:substringBefore(type, ' ') == 'date'}">
    <c:set var="dateformat" value="${su:substringAfter(type, ' ')}" />
    <c:set var="type" value="text" />
    <c:set var="datepickernew" value="${true}" />
  </c:if>
  <c:if test="${maxlength ge 256}">
    <c:set var="type" value="textarea" />
  </c:if>
  <c:set var="divclass">
    <jsp:text>formelement formelement${type}</jsp:text>
  </c:set>
  <c:set var="cssclass">
    <jsp:text>${type} ${cssclass}</jsp:text>
    <c:if test="${readonly}">${elx:space()}readonly</c:if>
  </c:set>
  <c:choose>
    <c:when test="${empty(label)}">
      <c:set var="labelmsg">
        <fmt:message key="${key}" />
      </c:set>
    </c:when>
    <c:otherwise>
      <c:set var="labelmsg">${label}</c:set>
    </c:otherwise>
  </c:choose>
  <!-- stampa campi -->
  <c:choose>
    <c:when test="${donothing}"><!-- don't print anything --></c:when>
    <c:when test="${!nobind}">
      <spring:bind path="${path}">
        <c:if test="${type == 'checkbox'}"></c:if>
        <c:choose>
          <c:when test="${type == 'checkbox'}">
            <c:if test="${status.value}">
              <c:set var="checked" value="${true}" />
            </c:if>
            <c:set var="value" value="${true}" />
          </c:when>
          <c:otherwise>
            <c:set var="value" value="${status.value}" />
          </c:otherwise>
        </c:choose>
        <c:set var="divclass">
          <jsp:text>${divclass}</jsp:text>
          <c:if test="${!empty(status.errorMessage)}">${elx:space()}formelementerror</c:if>
        </c:set>
        <c:choose>
          <c:when test="${bare}">
            <ou:txtinput type="${type}" name="${name}" value="${value}" cssclass="${cssclass}" maxlength="${maxlength}"
              style="${style}" readonly="${readonly}" disabled="${disabled}" onkeypress="${onkeypress}"
              onkeydown="${onkeydown}" onkeyup="${onkeyup}" onchange="${onchange}" onblur="${onblur}"
              checked="${checked}" />
          </c:when>
          <c:when test="${type == 'label'}">
            <div class="${divclass}">
              <label for="${name}">${labelmsg}</label>
              <span class="text">${status.value}</span>
              <div class="clear"><!--  --></div>
            </div>
          </c:when>
          <c:otherwise>
            <div class="${divclass}">
              <label for="${name}">${labelmsg}</label>
              <ou:txtinput type="${type}" name="${name}" value="${value}" cssclass="${cssclass}"
                maxlength="${maxlength}" style="${style}" readonly="${readonly}" disabled="${disabled}"
                onkeypress="${onkeypress}" onkeydown="${onkeydown}" onkeyup="${onkeyup}" onchange="${onchange}"
                onblur="${onblur}" checked="${checked}" />
              <c:if test="${datepicker}">
                <a href="javascript:showCal('divdata${name}','${name}')" title="seleziona" class="calbtn">
                  <span>C</span>
                </a>
                <div class="calendar" id="divdata${name}" style="display:none"><!--  --></div>
                &lt;!--[if gte IE 5.5]>
                <iframe id='divdata${name}iframe' class='calendarIframe' src='javascript:false;' frameBorder='0'
                  scrolling='no'
                  style="display:none;filter:progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)"><!-- x --></iframe>
                &lt;![endif]-->
                <script type="text/javascript">createCalendar('${status.value}', 'divdata${name}', '${name}')</script>
              </c:if>
              <c:if test="${datepickernew}">
                <a title="seleziona" class="calbtn" id="${name}_cal">
                  <span>C</span>
                </a>
                <script type="text/javascript">
                  <![CDATA[
                      Calendar.setup({
                          inputField     :    "${name}",      // id of the input field
                          ifFormat       :    "${dateformat}", // format of the input field, es "%Y-%m-%d %H:%M"
                          showsTime      :    true,            // will display a time selector
                          button         :    "${name}_cal",  // trigger for the calendar (button ID)
                          align          :    "Bl",           // alignment (defaults to "Bl")
                          singleClick    :    true
                      });
                  ]]>
                </script>
              </c:if>
              <div class="clear"><!--  --></div>
            </div>
          </c:otherwise>
        </c:choose>
      </spring:bind>
    </c:when>
    <c:otherwise><!-- no spring binding -->
      <c:choose>
        <c:when test="${bare}">
          <ou:txtinput type="${type}" name="${name}" value="${status.value}" cssclass="${cssclass}"
            maxlength="${maxlength}" style="${style}" readonly="${readonly}" disabled="${disabled}"
            onkeypress="${onkeypress}" onkeydown="${onkeydown}" onkeyup="${onkeyup}" onchange="${onchange}"
            onblur="${onblur}" checked="${checked}" />
        </c:when>
        <c:otherwise>
          <div class="${divclass}">
            <label for="${name}">${labelmsg}</label>
            <ou:txtinput type="${type}" name="${name}" value="${status.value}" cssclass="${cssclass}"
              maxlength="${maxlength}" style="${style}" readonly="${readonly}" disabled="${disabled}"
              onkeypress="${onkeypress}" onkeydown="${onkeydown}" onkeyup="${onkeyup}" onchange="${onchange}"
              onblur="${onblur}" checked="${checked}" />
            <div class="clear"><!--  --></div>
          </div>
        </c:otherwise>
      </c:choose>
    </c:otherwise>
  </c:choose>
</jsp:root>
