<jsp:root version="2.0" xmlns:jsp="http://java.sun.com/JSP/Page"
    xmlns:spring="http://www.springframework.org/tags" xmlns:c="http://java.sun.com/jsp/jstl/core"
    xmlns:fmt="http://java.sun.com/jsp/jstl/fmt" xmlns:su="http://openutils.sourceforge.net/openutils-tags-commonslang"
    xmlns:ou="http://openutils.sourceforge.net/openutils-tags-spring" xmlns:elx="http://openutils.sourceforge.net/openutils-tags-elx">

    <jsp:directive.attribute name="path" required="true" />
    <jsp:directive.attribute name="maxlength" required="false" />

    <c:set var="name">${su:substringAfter(path, ".")}</c:set>
    <c:set var="bean">${su:substringBefore(path, ".")}</c:set>
    <c:if test="${empty(maxlength)}">
      <c:set var="maxlength">30</c:set>
    </c:if>
    <c:set var="value" value="${elx:getProperty(requestScope[bean],name)}" />
    <c:if test="${elx:isempty(value)}">
      <jsp:scriptlet>java.util.Map map = new java.util.HashMap(1);map.put("","");jspContext.setAttribute("value", map);</jsp:scriptlet>
    </c:if>
    <c:set var="languages" value="${su:split('IT EN FR DE ES',' ')}" />

    <script type="text/javascript">
<![CDATA[
function tblangAdd(lid)
{
 element = lid.parentNode;
 row = element.childNodes[0];
 cloned = row.cloneNode(true);
 for (j=0;cloned.childNodes[j];j++) { if (cloned.childNodes[j].nodeType == 1) { cloned.childNodes[j].value=""; } }
 element.appendChild(cloned);
 element.appendChild(lid);
 return false;
}
function tblangDel(lid)
{
 element = lid.parentNode;
 if (element.parentNode.childNodes.length > 2) {
   element.parentNode.removeChild(element);
 }else{
   for (j=0;element.childNodes[j];j++) { if (element.childNodes[j].nodeType == 1) { element.childNodes[j].value=""; } }
 }
 return false;
}
]]>
	</script>

    <spring:bind path="${path}">
        <c:set var="divclass">formelement tblang <c:if test="${!empty(status.errorMessage)}"> formelementerror</c:if>
        </c:set>

        <div class="${divclass}">
            <label for="${name}"><fmt:message key="${path}" />:</label>

            <div class="tblangentry">
	            <c:forEach items="${value}" var="item" varStatus="idx">
	                <div id="${name}${idx.index}">
			            <ou:txtselect name="${name}">
			                <c:forEach items="${languages}" var="language">
			                   <ou:txtoption selected="${item.key == language}" value="¶${language}">${language}</ou:txtoption>
			                </c:forEach>
			            </ou:txtselect>

			            <c:choose>
			              <c:when test="${maxlength le 256}">
			                <input type="text" name="${name}" value="${item.value}" maxlength="${maxlength}" class="tblanginput"/>
			              </c:when>
			              <c:otherwise>
			                <ou:txttextarea name="${name}" value="${item.value}" cssclass="tblangtextarea"/>
			              </c:otherwise>
			            </c:choose>

			            <a href="#" class="tblangDel" onclick="return tblangDel(this)">-</a>
		            </div>
	            </c:forEach>
	            <a href="#" class="tblangAdd" onclick="return tblangAdd(this)">+</a>
            </div>
        </div>
    </spring:bind>
</jsp:root>
