package it.openutils.web.tag.debug;

import java.net.InetAddress;
import java.net.UnknownHostException;
import java.util.Enumeration;
import java.util.HashMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;


/**
 * @author fgiust
 * @version $Revision: 253 $ ($Author: fgiust $)
 */
public class DebugHeadersTag extends BaseDebugTag
{

    /**
     * Stable <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 222;

    /**
     * crea l'HashMap che evrr� stampata nel metodo doEndTag()
     * @return int
     * @throws JspException eccezione generica
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    @Override
    public int doStartTag() throws JspException
    {

        HashMap map = new HashMap();

        HttpServletRequest request = (HttpServletRequest) pageContext.getRequest();
        Enumeration enm = request.getHeaderNames();

        while (enm.hasMoreElements())
        {
            String key = enm.nextElement().toString();
            Object value = request.getHeader(key);
            map.put(key, value);
        }

        String remoteHost = request.getRemoteHost();
        map.put("getRemoteHost", remoteHost);
        map.put("getRemoteUser", request.getRemoteUser());
        map.put("getCharacterEncoding", request.getCharacterEncoding());
        map.put("getAuthType", request.getAuthType());
        map.put("getAuthType", request.getAuthType());
        map.put("getPathInfo", request.getPathInfo());
        map.put("getPathTranslated", request.getPathTranslated());
        map.put("getMethod", request.getMethod());

        if (remoteHost != null)
        {
            try
            {
                map.put("getHostName(remoteHost)", InetAddress.getByName(remoteHost).getHostName());
            }
            catch (UnknownHostException e)
            {
                map.put("getHostName(remoteHost)", "UnknownHostException!");
            }
        }

        setOutputClassName(false);
        setDebugMap(map);

        return super.doStartTag();
    }
}