package it.openutils.web.tag.debug;

import java.util.Enumeration;
import java.util.HashMap;

import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;


/**
 * @author fgiust
 * @version $Revision: 253 $ ($Author: fgiust $)
 */
public class DebugParametersTag extends BaseDebugTag
{

    /**
     * Stable <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 222;

    /**
     * crea l'HashMap che verr� stampata nel metodo doEndTag()
     * @return int
     * @throws JspException eccezione generica
     * @see javax.servlet.jsp.tagext.Tag#doStartTag()
     */
    @Override
    public int doStartTag() throws JspException
    {

        HashMap map = new HashMap();

        ServletRequest request = pageContext.getRequest();
        Enumeration enm = request.getParameterNames();

        while (enm.hasMoreElements())
        {
            String key = enm.nextElement().toString();
            Object value = request.getParameter(key);
            map.put(key, value);
        }

        setOutputClassName(false);
        setDebugMap(map);

        return super.doStartTag();
    }

}
